%bcond_without check

# https://github.com/noisetorch/NoiseTorch
%global goipath             github.com/noisetorch/NoiseTorch
Version:                    0.12.2
%global tag                 v%{version}

# Dependencies
%global rnnoise_commit      1cbdbcf1283499bbb2230a6b0f126eb9b236defd
%global rnnoise_shortcommit %(c=%{rnnoise_commit}; echo ${c:0:7})
%global ringbuf_commit      2037560fb90dea5d2538611d983964d790bdbac2
%global ringbuf_shortcommit %(c=%{ringbuf_commit}; echo ${c:0:7})

%gometa

%global common_description Real-time microphone noise suppression on Linux.

%global golicenses      LICENSE
%global godocs          README.md

Name:           noisetorch
Release:        2%{?dist}
Summary:        Real-time microphone noise suppression on Linux

License:        GPLv3
URL:            %{gourl}
Source0:        %{gosource}
# rnnoise: https://github.com/noisetorch/rnnoise
Source1:        https://github.com/%{name}/rnnoise/archive/%{rnnoise_commit}/rnnoise-%{rnnoise_shortcommit}.tar.gz
# c-ringbuf: https://github.com/noisetorch/c-ringbuf
Source2:        https://github.com/%{name}/c-ringbuf/archive/%{ringbuf_commit}/c-ringbuf-%{ringbuf_shortcommit}.tar.gz

BuildRequires:  desktop-file-utils

%description
%{common_description}

%gopkg

%prep
%goprep -k
tar xzf %{SOURCE1} --strip-components 1 -C c/rnnoise
tar xzf %{SOURCE2} --strip-components 1 -C c/c-ringbuf

%build

%make_build -C c/ladspa
go generate
export LDFLAGS="-X main.version=%{version} -X 'main.distribution=Fedora Linux'"
%gobuild -o %{gobuilddir}/bin/noisetorch %{goipath} 


%install
%gopkginstall
install -m 0755 -vd                     %{buildroot}%{_bindir}
install -m 0755 -vp %{gobuilddir}/bin/* %{buildroot}%{_bindir}/

desktop-file-install                                    \
--dir=%{buildroot}%{_datadir}/applications              \
--set-icon=noisetorch                                   \
%{gobuilddir}/../assets/noisetorch.desktop

install -m 0755 -vd                                             %{buildroot}%{_datadir}/icons/hicolor/256x256/apps
install -m 0664 -vp %{gobuilddir}/../assets/icon/noisetorch.png %{buildroot}%{_datadir}/icons/hicolor/256x256/apps/noisetorch.png


%if %{with check}
%check
%gocheck
%endif

%files
%license LICENSE
%doc README.md
%{_bindir}/*
%{_datadir}/applications/noisetorch.desktop
%{_datadir}/icons/hicolor/256x256/apps/noisetorch.png

%gopkgfiles

%post
setcap cap_sys_resource+eip %{_bindir}/noisetorch

%changelog
* Tue Nov 29 2022 Arthur Bols <arthur@bols.dev> - 0.12.2-2
- Rebuilt for Fedora 37
* Sun Jun 19 2022 Arthur Bols <arthur@bols.dev> - 0.12.2-1
- Upstream release 0.12.2.
* Thu Jun 02 2022 Arthur Bols <arthur@bols.dev> - 0.12.0-1
- Update spec for upstream organisation changes.
- Upstream release 0.12.0.
* Mon Apr 18 2022 Arthur Bols <arthur@bols.dev> - 0.11.5-1
- Upstream release 0.11.5.
* Fri Dec 17 2021 Arthur Bols <arthur@bols.dev> - 0.11.4-1
- Upstream release 0.11.4.
* Sun Jun 06 2021 Arthur Bols <arthur@bols.dev> - 0.11.3-1
- Upstream release 0.11.3.
* Wed May 26 2021 Arthur Bols <arthur@bols.dev> - 0.11.2-1
- Upstream release 0.11.2.
- Set CAP_SYS_RESOURCE in post.
* Mon Feb 22 2021 Arthur Bols <arthur@bols.dev> - 0.10.1-1
- Upstream release 0.10.1.
* Wed Feb 10 2021 Arthur Bols <arthur@bols.dev> - 0.10.0-1
- Initial package
